Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/GYRE/EXP00/namelist_cfg
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/GYRE/EXP00/namelist_cfg	(revision 7001)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/GYRE/EXP00/namelist_cfg	(revision 7002)
@@ -25,7 +25,7 @@
 &namcfg     !   parameters of the configuration   
 !-----------------------------------------------------------------------
-   ln_read_cfg = .false.   !  (=T) read the domain configuration in 'domain_cfg.nc" file
+   ln_read_cfg = .true.    !  (=T) read the domain configuration in 'domain_cfg.nc" file
    !                       !  (=F) user defined configuration  ==>>>  see usrdef(_...) modules
-   ln_write_cfg= .true.    !  (=T) create the domain configuration file
+   ln_write_cfg= .false.   !  (=T) create the domain configuration file
    !
    cp_cfg      = "default" !  name of the configuration
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/ORCA2_SAS_LIM/cpp_ORCA2_SAS_LIM.fcm
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/ORCA2_SAS_LIM/cpp_ORCA2_SAS_LIM.fcm	(revision 7001)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/ORCA2_SAS_LIM/cpp_ORCA2_SAS_LIM.fcm	(revision 7002)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_trabbl key_lim2  key_zdftke key_zdfddm key_zdftmx key_iomput key_mpp_mpi kep_mpp_rep
+ bld::tool::fppkeys key_trabbl key_lim2  key_zdftke key_zdfddm key_zdftmx key_iomput key_mpp_mpi key_mpp_rep
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/sette.sh
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/sette.sh	(revision 7001)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/sette.sh	(revision 7002)
@@ -138,5 +138,5 @@
 # ORCA2_LIM3      : 7 &  8
 # AMM12           : 9 & 10
-# SAS             :11 & 12
+# SAS             :11 
 # ISOMIP          :13 & 14
 # ORCA2_LIM_OBS   :15
@@ -144,6 +144,5 @@
 #                  18 & 19 
 
-for config in  1 2 3 4 7 8 9 10 11 12 15 
-#SF for config in  1 2 3 4 5 6 7 8 9 10 11 12 15 16
+for config in  1 2 3 4 5 6 7 8 9 10 11 12 15 16
 
 do
@@ -910,5 +909,5 @@
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
-    \rm $JOB_FILE
+    if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"SAS\"
@@ -949,4 +948,9 @@
     set_namelist namelist_cfg nn_rstctl 2
     set_namelist namelist_cfg cn_ocerst_in \"SAS_00000050_restart\"
+    if [ ${USING_MPMD} == "yes" ] ; then
+       set_xio_using_server iodef.xml true
+    else
+       set_xio_using_server iodef.xml false
+    fi
     for (( i=1; i<=$NPROC; i++)) ; do
         L_NPROC=$(( $i - 1 ))
@@ -954,9 +958,4 @@
         ln -sf ../LONG/SAS_00000050_restart_${L_NPROC}.nc .
     done
-    if [ ${USING_MPMD} == "yes" ] ; then
-       set_xio_using_server iodef.xml true
-    else
-       set_xio_using_server iodef.xml false
-    fi
     cd ${SETTE_DIR}
     . ./prepare_job.sh input_SAS.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
@@ -965,62 +964,4 @@
 fi
 
-if [ ${config} -eq 12 ] ;  then
-## Reproducibility tests for ORCA2_SAS_LIM
-    export TEST_NAME="REPRO_8_4"
-    cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n SAS_32 -r ORCA2_SAS_LIM -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
-    cd ${SETTE_DIR}
-    . ./param.cfg
-    . ./all_functions.sh
-    . ./prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=32
-    \rm ${JOB_FILE}
-    cd ${EXE_DIR}
-    set_namelist namelist_cfg cn_exp \"SAS\"
-    set_namelist namelist_cfg nn_it000 51
-    set_namelist namelist_cfg nn_itend 100
-    set_namelist namelist_cfg ln_ctl .false.
-    set_namelist namelist_cfg ln_clobber .true.
-    set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg nn_fwb 0
-    set_namelist namelist_cfg jpni 8
-    set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg jpnij 32
-    if [ ${USING_MPMD} == "yes" ] ; then
-       set_xio_using_server iodef.xml true
-    else
-       set_xio_using_server iodef.xml false
-    fi
-    cd ${SETTE_DIR}
-    . ./prepare_job.sh input_SAS.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE}  ${NUM_XIOSERVERS}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
-    cd ${SETTE_DIR}
-    export TEST_NAME="REPRO_4_8"
-    . ./prepare_exe_dir.sh
-    cd ${EXE_DIR}
-    set_namelist namelist_cfg cn_exp \"SAS\"
-    set_namelist namelist_cfg nn_it000 51
-    set_namelist namelist_cfg nn_itend 100
-    set_namelist namelist_cfg ln_ctl .false.
-    set_namelist namelist_cfg ln_clobber .true.
-    set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg nn_fwb 0
-    set_namelist namelist_cfg jpni 4
-    set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg jpnij 32
-    if [ ${USING_MPMD} == "yes" ] ; then
-       set_xio_using_server iodef.xml true
-    else
-       set_xio_using_server iodef.xml false
-    fi
-    cd ${SETTE_DIR}
-    . ./prepare_job.sh input_SAS.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS}
-    cd ${SETTE_DIR}
-    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
-fi
 # TESTS FOR ISOMIP CONFIGURATION
 if [ ${config} -eq 13 ] ;  then
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh	(revision 7001)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh	(revision 7002)
@@ -44,5 +44,5 @@
 # ::
 #
-#  $ ./Fadd_keys.sh ORCA2_LIM add_key "key_mpp_mpi key_nproci=1 key_nprocj=10"
+#  $ ./Fadd_keys.sh ORCA2_LIM add_key "key_mpp_rep"
 #
 #
@@ -65,16 +65,10 @@
  echo "Adding keys in : ${NEW_CONF}" 
  for i in ${list_add_key} ; do
-	if [ "$(echo ${i} | grep -c key_nproc )" -ne 0 ] ; then
-		sed -e "s/key_nproc[ij]=.[0-9]* //"  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
-       	 	mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp   ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
-		echo " "
-		sed -e "s/$/ ${i}/"  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
-       	 	mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp   ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
-	elif [ "$(cat ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm | grep -c "$i" )" -ne 0 ] ; then
- 	echo "key $i already present in cpp_${NEW_CONF}.fcm" 
+	if [ "$(cat ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm | grep -c "$i" )" -ne 0 ] ; then
+ 	   echo "key $i already present in cpp_${NEW_CONF}.fcm" 
 	else
-	sed -e "s/$/ ${i}/"  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
- 	mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp   ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
- 	echo "added key $i in ${NEW_CONF}" 
+	   sed -e "s/$/ ${i}/"  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
+ 	   mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp   ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
+ 	   echo "added key $i in ${NEW_CONF}" 
 	fi
  done