Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_cfg
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_cfg	(revision 7004)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist_cfg	(revision 7005)
@@ -6,10 +6,20 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-/
-!-----------------------------------------------------------------------
-&namcfg        !   parameters of the configuration
-!-----------------------------------------------------------------------
-   cp_cfg      =  "orca"               !  name of the configuration
-   jp_cfg      =       2               !  resolution of the configuration
+   nn_no       =       0       !  job number (no more used...)
+   cn_exp      =  "ORCA2_PIS"  !  experience name
+   nn_it000    =       1       !  first time step
+   nn_itend    =    5475       !  last  time step (std 5475)
+/
+!-----------------------------------------------------------------------
+&namcfg     !   parameters of the configuration
+!-----------------------------------------------------------------------
+   ln_read_cfg = .true.   !  (=T) read the domain configuration in 'domain_cfg.nc" file
+   !                       !  (=F) user defined configuration  ==>>>  see usrdef(_...) modules
+   ln_write_cfg= .false.    !  (=T) create the domain configuration file
+   !
+   cp_cfg      =  "orca"   !  name of the configuration
+   jp_cfg      =       2   !  resolution of the configuration
+   ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
+   !                       !  in netcdf input files, as the start j-row for reading
 /
 !-----------------------------------------------------------------------
@@ -17,20 +27,12 @@
 !-----------------------------------------------------------------------
    ln_zps      = .true.    !  z-coordinate - partial steps
-   ln_linssh   = .true.    !  linear free surface
 /
 !-----------------------------------------------------------------------
 &namdom        !   space and time domain (bathymetry, mesh, timestep)
 !-----------------------------------------------------------------------
-   ppsur       =   -4762.96143546300   !  ORCA r4, r2 and r05 coefficients
-   ppa0        =     255.58049070440   ! (default coefficients)
-   ppa1        =     245.58132232490   !
-   ppkth       =      21.43336197938   !
-   ppacr       =       3.0             !
-   ppdzmin     =  999999.              !  Minimum vertical spacing
-   pphmax      =  999999.              !  Maximum depth
-   ldbletanh   =  .FALSE.              !  Use/do not use double tanf function for vertical coordinates
-   ppa2        =  999999.              !  Double tanh function parameters
-   ppkth2      =  999999.              !
-   ppacr2      =  999999.              !
+   ln_linssh   = .false.   !  =T  linear free surface  ==>>  model level are fixed in time
+   !
+   nn_msh      =    0      !  create (>0) a mesh file or not (=0)
+   !
 /
 !-----------------------------------------------------------------------
@@ -115,6 +117,6 @@
    ln_traldf_lev   =  .false.  !  iso-level
    ln_traldf_hor   =  .false.  !  horizontal (geopotential)
-   ln_traldf_iso   =  .true.   !  iso-neutral (standard operator)
-   ln_traldf_triad =  .false.  !  iso-neutral (triad    operator)
+   ln_traldf_iso   =  .true.   !  iso-neutral (Standard operator)
+   ln_traldf_triad =  .false.  !  iso-neutral (Triads   operator)
    !
    !		       	         !  iso-neutral options:        
@@ -152,5 +154,5 @@
 /
 !-----------------------------------------------------------------------
-&namtra_dmp    !   tracer: T & S newtonian damping
+&namtra_dmp    !   tracer: T & S newtonian damping                      (default: NO)
 !-----------------------------------------------------------------------
 /
@@ -200,4 +202,6 @@
    rn_ahm_b      =      0.     !  background eddy viscosity for ldf_iso [m2/s]
    rn_bhm_0      = 1.e+12      !  horizontal bilaplacian eddy viscosity [m4/s]
+   !
+   ! Caution in 20 and 30 cases the coefficient have to be given for a 1 degree grid (~111km)
 /
 !-----------------------------------------------------------------------
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 7004)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 7005)
@@ -806,6 +806,6 @@
 !-----------------------------------------------------------------------
    ln_hpg_zco  = .false.   !  z-coordinate - full steps
-   ln_hpg_zps  = .true.    !  z-coordinate - partial steps (interpolation)
-   ln_hpg_sco  = .false.   !  s-coordinate (standard jacobian formulation)
+   ln_hpg_zps  = .false.   !  z-coordinate - partial steps (interpolation)
+   ln_hpg_sco  = .true.    !  s-coordinate (standard jacobian formulation)
    ln_hpg_isf  = .false.   !  s-coordinate (sco ) adapted to isf
    ln_hpg_djc  = .false.   !  s-coordinate (Density Jacobian with Cubic polynomial)
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 7004)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 7005)
@@ -1,1 +1,1 @@
-ORCA2_LIM_nemo_v3.6.tar  ORCA2_LIM_PISCES_v3.6
+ORCA2_LIM_nemo_v3.7.tar  ORCA2_LIM_PISCES_v3.7
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/input_ORCA2_OFF_PISCES.cfg
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/input_ORCA2_OFF_PISCES.cfg	(revision 7004)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/input_ORCA2_OFF_PISCES.cfg	(revision 7005)
@@ -1,1 +1,1 @@
-INPUTS_DYNA_v3.6.tar ORCA2_OFF_PISCES
+INPUTS_DYNA_v3.7.tar ORCA2_OFF_PISCES_3.7
Index: /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/sette.sh
===================================================================
--- /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/sette.sh	(revision 7004)
+++ /branches/2016/dev_r6409_SIMPLIF_2_usrdef/NEMOGCM/SETTE/sette.sh	(revision 7005)
@@ -133,16 +133,16 @@
 cp BATCH_TEMPLATE/${JOB_PREFIX}-${COMPILER} job_batch_template || exit
 # Description of configuration tested:
-# GYRE            : 1 &  2
-# ORCA2_LIM_PISCES: 3 &  4
-# ORCA2_OFF_PISCES: 5 &  6
-# ORCA2_LIM3      : 7 &  8
-# AMM12           : 9 & 10
-# SAS             :11 
-# ISOMIP          :13 & 14
-# ORCA2_LIM_OBS   :15
-# ORCA2_AGRIF_LIM :16 & 17 
-#                  18 & 19 
-
-for config in  1 2 3 4 5 6 7 8 9 10 11 12 15 16
+# GYRE             :  1 &  2
+# ORCA2_LIM_PISCES :  3 &  4
+# ORCA2_OFF_PISCES :  5 &  6
+# ORCA2_LIM3       :  7 &  8
+# AMM12            :  9 & 10
+# SAS              : 11      fos SAS there is no solver so is usefull to test REPRO
+# ISOMIP           : 13 & 14
+# ORCA2_LIM_OBS    : 15
+# ORCA2_AGRIF_LIM  : 16 & 17 
+#                    18 & 19 
+
+for config in  1 2 3 4 5 6 7 8 9 10 11 16
 
 do
@@ -858,4 +858,6 @@
     set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg ln_clobber .true.
+    set_namelist namelist_cfg ln_read_cfg .true.
+    set_namelist namelist_cfg ln_linssh .false.
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
@@ -882,4 +884,6 @@
     set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg ln_clobber .true.
+    set_namelist namelist_cfg ln_read_cfg .true.
+    set_namelist namelist_cfg ln_linssh .false.
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
@@ -1155,4 +1159,6 @@
     set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg ln_clobber .true.
+    set_namelist namelist_cfg ln_read_cfg .true.
+    set_namelist namelist_cfg ln_linssh .false.
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 8